# -*- encoding: utf-8 -*-
##############################################################################
#
#    Product hardware revision module for OpenERP
#    Copyright (C) 2009-2010 Anevia S.A. (www.anevia.com),
#       code written by Raphaêl Valyi from Smile.fr,
#           now working at Akretion.com <rvalyi@akretion.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class product_hardware_revision(osv.osv):
    _name = "product.hardware.revision"
    _description = "Product Hardware Revision"

    _columns = {
        'name': fields.char('Name', size=64, required=True),
        'revision': fields.char('Revision', size=16),
        'product_id': fields.many2one('product.template', 'Product template'),
    }

product_hardware_revision()


class product_template(osv.osv):
    _inherit = "product.template"

    _columns = {
        'hardware_revision_ids': fields.one2many('product.hardware.revision', 'product_id', 'Hardware Revisions'),
        'current_default_revision_id': fields.many2one('product.hardware.revision', 'Current Default Revision', domain="[('product_id', '=', active_id)]"),
    }

product_template()
