# -*- encoding: utf-8 -*-
##############################################################################
#
#    Product loan module for OpenERP
#    Copyright (C) 2009-2010 Anevia S.A. (www.anevia.com),
#       code written by Raphaêl Valyi from Smile.fr,
#           now working at Akretion.com <rvalyi@akretion.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    "name" : "Product Loan",
    "description":"""Module to manage loan of products. Under Sales management, you get a new menu to create and follow your loans. A loan is a special sale order with :
    - a start date
    - an end date
    - a prodlot for every sale order line, to designate which product of the loan pool will be sent.

    When validated, the loan-type sale order will create both :
    - an outgoing products with source stock = "loan in", destination stock = "loan out" (configurable) and planned date = loan start date. You will not be able to create an invoice from this outgoing product.
    - an incoming products with source stock = "loan out", destination stock = "loan in" and planned date = loan end date.
    Prodlots that can be select as a loan should be in one of the loan stocks (loan in or loan out) and have a salesman associated with it. Every salesman has it's own pool of loaned prodlots and can create loans only with his own pool of prodlots.""",
    "version" : "0.1",
    "author" : "Anevia",
    "website": "http://www.anevia.com/",
    "license": "AGPL-3",
    "category" : "Custom",
    "depends" : ["stock", "sale"],
    "init_xml" : [],
    "demo_xml" : [],
    "update_xml" : ["stock_data.xml", "sale_view.xml", "stock_view.xml", "loan_sequence.xml", "sale_report.xml"],
    "active": False,
    "installable": True
}
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
