# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""inherits from stock.picking for fix and add functionality"""

from osv import osv
import netsvc
from tools.translate import _

class stock_picking(osv.osv):
    """inherits from stock.picking for fix and add functionality"""
    _inherit = "stock.picking"
    _order = "date desc"
    
    def test_finnished(self, cr, uid, ids):
        """overwrite this method because now field procurements not works"""
        wf_service = netsvc.LocalService("workflow")
        #CHECKME: res = super(stock_picking, sel).test_finnished(cursor, user, ids) not works because call test.finnished in mrp.py and then stock.py. must call only base method in stock.py
        #
        #code copied from test_finnished method in stock.py
        #
        move_ids = self.pool.get('stock.move').search(cr, uid, [('picking_id', 'in', ids)])
        for move in self.pool.get('stock.move').browse(cr, uid, move_ids):
            if move.state not in ('done', 'cancel') :
                if move.product_qty != 0.0 or not move.prodlot_id:
                    return False
                else:
                    move.write(cr, uid, [move.id], {'state':'done'})
        #
        for picking in self.browse(cr, uid, ids):
            for move in picking.move_lines:
                if move.state == 'done' and move.procurement_id:
                    wf_service.trg_validate(uid, 'mrp.procurement',
                            move.procurement_id.id, 'button_check', cr)
        return True

    def write(self, cr, uid, ids, data, context = {}):
        """overwrites write method to have address_id always in stock.picking internal type"""

        add_address = False
        if not isinstance(ids, list):
            ids = [ids]
        for picking_id in self.browse(cr, uid, ids):
            if picking_id.type == 'internal' and not picking_id.address_id:
                add_address = True

        if 'type' in data and data['type'] == 'internal' or add_address:
            if ('address_id' in data and not data['address_id']) or not 'address_id' in data:
                active_partner_obj_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.partner_id
                addresses = self.pool.get('res.partner.address').search(cr, uid, [('partner_id', '=', active_partner_obj_id.id), ('type', '=', 'default')])
                if addresses:
                    data['address_id'] = addresses[0]
                elif active_partner_obj_id.address:
                    data['address_id']  = active_partner_obj_id.address[0].id
                else:
                    raise osv.except_osv(_('Warning'), _("Active partner need address!"))
        return super(stock_picking, self).write(cr, uid, ids, data, context = context)


stock_picking()