# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Pexego Sistemas Informáticos. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""
Manages prodlots sequences by product
"""


import pooler

def get_default_seq_id_for_prodlot(cr, uid, product_id, seq_code = 'generic.stock.lot.serial'):
    """
    Get by default a sequence for active product.
    If the sequence not exists it creates.
    """
    pool = pooler.get_pool(cr.dbname)
    #
    # Generamos el nombre de la secuencia
    #
    obj_product_id = pool.get('product.product').browse(cr, uid, product_id)

    product_infix = obj_product_id.default_code + "/"

    sequence_name = "%s %s" % (product_infix, obj_product_id.name)

    #
    # Buscamos la secuencia
    #
    sequence_ids = pool.get('ir.sequence').search(cr, uid, [('code', '=', seq_code), ('name', '=', sequence_name)])

    if len(sequence_ids) > 0:
        sequence_id = sequence_ids[0]
    else:
        #
        # Creamos una nueva secuencia
        #
        sequence_id = pool.get('ir.sequence').create(cr, uid, {
            'name': sequence_name,
            'code': seq_code,
            'padding': 3,
            'prefix': "L%(doy)s%(y)s (" + product_infix,
            'suffix': ")"
        })

    return sequence_id