# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""wizard to emptied a location"""

import wizard
import pooler
from mx.DateTime import now
from tools.translate import _

ARCH_END = '''<?xml version = "1.0"?>
<form string = "Empty location result">
    <label string = "The location has been successfully emptied !" colspan = "4"/>
</form>'''

FIELDS_END = {}

def _empty_inventory(self, cr, uid, data, context):
    """empty a location"""
    pool = pooler.get_pool(cr.dbname)
    inventory_line_obj = pooler.get_pool(cr.dbname).get('stock.inventory.line')
    location_obj = pooler.get_pool(cr.dbname).get('stock.location')
    res = {}
    res_location = {}
    if data['id']:
        # pylint: disable-msg=W0212
        res = location_obj._product_get(cr, uid, data['id'], context = context)
        res_location[data['id']] = res
        product_ids = []
        inventory_id = pool.get('stock.inventory').create(cr, uid, {'name': "INV:" + now().strftime('%Y-%m-%d %H:%M:%S'),
                                                                  'date': now().strftime('%Y-%m-%d %H:%M:%S'),
                                           })
        for location in res_location.keys():
            res = res_location[location]
            for product_id in res.keys():
                cr.execute('select prodlot_id, name as id from stock_report_prodlots where location_id = %s and product_id = %s and name > 0', (location, product_id))
                prodlots = cr.fetchall()
                for prodlot in prodlots:
                    prod = pool.get('product.template').browse(cr, uid, product_id)
                    amount = prodlot[1]

                    if(amount):
                        inventory_line = {'inventory_id':inventory_id, 'location_id':location, 'product_id':product_id, 'product_uom':prod.uom_id.id, 'product_qty':0, 'prodlot_id':prodlot[0]}
                        inventory_line_obj.create(cr, uid, inventory_line)
                        product_ids.append(product_id)
        pool.get('stock.inventory').action_done(cr, uid, [inventory_id], context = context)

    if len(product_ids) == 0:
        raise wizard.except_wizard(_('Message !'), _('No product in this location.'))
    return {}

class empty_inventory(wizard.interface):
    """wizard to emptied a location"""
    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'action',
                    'action': _empty_inventory, 'state' : 'end2'}
                    },
        'end2' : {
            'actions': [],
            'result': {'type': 'form', 'arch': ARCH_END,
                'fields': FIELDS_END,
                'state': (
                    ('end', 'Close'),
                )
            }
        },
    }
empty_inventory("stock.liquid.traceability.empty_inventory")



