# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""wizard that replace completely the wizard on stock with same name,
beacause adds the functionally that set zero prodlotas not products"""

import wizard
import pooler
from tools.translate import _


FORM = """<?xml version="1.0"?>
<form string="Set Stock to Zero">
    <separator colspan="4" string="Set Stocks to Zero" />
    <field name="location_id"/>
    <newline/>
    <label colspan="4" string="Do you want to set stocks to zero ?"/>
</form>
"""
FIELDS = {
    'location_id' : {
        'string':'Location',
        'type':'many2one',
        'relation':'stock.location',
        'required':True
        }
}


def do_merge(self, cr, uid, data, context):
    """set to zero the prodlots in a location"""
    #gets the objects
    invent_line_obj = pooler.get_pool(cr.dbname).get('stock.inventory.line')
    prod_obj =  pooler.get_pool(cr.dbname).get('stock.production.lot')

    if len(data['ids']) != 1:
        raise wizard.except_wizard(_("Warning"),
                                   _("Please select one and only one inventory !"))
    #gets the location from a textbox in the form
    loc = str(data['form']['location_id'])
    
    #deletes any inventory line already exists
    cr.execute('delete from stock_inventory_line where inventory_id=%s', (data['ids'][0],))
    #gets the products in this location
    cr.execute('select distinct product_id from stock_move where (location_dest_id='+loc+') or (location_id='+loc+')')
    locations_stock = cr.fetchall()
    for stock in locations_stock:
        #gets the valid prodlots for the product in location
        cr.execute('select prodlot_id,name as id from stock_report_prodlots where location_id = %s and product_id = %s and name > 0', (loc, stock[0]))
        prodlots = cr.fetchall()
        #creates the inventory lines
        for prodlot_id in prodlots:
            obj_prodlot_id = prod_obj.browse(cr, uid, prodlot_id[0])
            if obj_prodlot_id.product_id.type == 'product':
                invent_line_obj.create(cr, uid, {
                                        'inventory_id': data['ids'][0],
                                        'location_id': loc,
                                        'product_id': stock[0],
                                        'product_uom': obj_prodlot_id.uom_id.id,
                                        'product_qty': 0.0,
                                        'prodlot_id': obj_prodlot_id.id
                                    })
    return {}


class merge_inventory(wizard.interface):
    """wizard that replace completely the wizard on stock with same name,
    beacause adds the functionally that set zero prodlotas not products"""
    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form',
                    'arch' : FORM,
                    'fields' : FIELDS,
                    'state' : [('end', 'Cancel'),
                               ('merge', 'Set to Zero') ]}
        },
        'merge' : {
            'actions' : [],
            'result' : {'type' : 'action',
                        'action': do_merge,
                        'state' : 'end'}
        },
    }
merge_inventory("stock.liquid.traceability.merge.stock.zero")

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

