# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""mrp_production inherit for manage final cost price"""

from osv import osv
from tools.translate import _

class mrp_production(osv.osv):
    """mrp_production inherit for manage final cost price"""
    _inherit = 'mrp.production'

    def action_compute_price(self, cr, uid, ids, context = {}):
        """calcula el precio del lote final"""
        production_obj_id = self.browse(cr, uid, ids[0])
        #producto a producir
        final_product_id = production_obj_id.product_id.id
        for final_move_obj_id in production_obj_id.move_created_ids:
            if final_move_obj_id.product_id.id == final_product_id and not final_move_obj_id.prodlot_id:
                raise osv.except_osv(_('Warning!'), _('Must assign first production lot in principal final move with product: %s') % final_move_obj_id.product_id.name)
            elif final_move_obj_id.product_id.id == final_product_id:
                total_price = 0.0
                for move_line in production_obj_id.move_lines:
                    total_price += move_line.price
                unit_price = total_price / final_move_obj_id.product_qty
                self.pool.get('stock.production.lot').write(cr, uid, [final_move_obj_id.prodlot_id.id], {'unit_price': unit_price})
                break
        return True


mrp_production()