# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""stock_picking inherit for modified workflow process now behavior"""

from osv import osv
import netsvc

class stock_picking(osv.osv):
    """stock_picking inherit for modified workflow process now behavior"""
    _inherit = 'stock.picking'

    def draft_validate(self, cr, uid, ids, *args):
        """overwrites thia method to avoid workflow finished"""
        wf_service = netsvc.LocalService("workflow")
        self.draft_force_assign(cr, uid, ids)
        for pick in self.browse(cr, uid, ids):
            move_ids = [x.id for x in pick.move_lines]
            self.pool.get('stock.move').force_assign(cr, uid, move_ids)
            wf_service.trg_write(uid, 'stock.picking', pick.id, cr)

            #This method is equal but comments this lines for avoid button_done was called
            #self.action_move(cr, uid, [pick.id])
            #wf_service.trg_validate(uid, 'stock.picking', pick.id, 'button_done', cr)
        return True

stock_picking()