# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""adds a compute product_qty about prodlot_product_uom"""

from osv import osv

class stock_report_prodlots(osv.osv):
    """adds a compute product_qty with prodlot.product_uom"""
    _inherit = "stock.report.prodlots"

    def read(self,cr, uid, ids, fields=None, context=None, load='_classic_read'):
        """overwrites read method to compute product qty with product uom in prodlot"""
        result = super(stock_report_prodlots, self).read(cr, uid, ids, fields, context, load)
        for res in result:
            if res.get('prodlot_id', False) and res.get('name', False):
                res['name'] = float(res['name']) * float(self.pool.get('stock.production.lot').browse(cr, uid, res['prodlot_id'][0]).product_uom.factor)
        return result

stock_report_prodlots()