# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""inherit res.partner for adds the functionally that a partner have a location"""

from osv import osv

class res_partner(osv.osv):
    """inherit res.partner for adds the functionally that a partner have a location"""
    _inherit = 'res.partner'

    def create(self, cr, uid, vals, context={}):
        """Overrides the insert method, for creates a specific customer location for a specific partner"""
        partner_id = super(res_partner, self).create(cr, uid, vals, context = context)
        if partner_id:
            partner_id_obj = self.browse(cr, uid, partner_id)
            if partner_id_obj.customer:
                #creates a customer location for a specific partner if the partner is a costumer
                partner_location_id = self.pool.get('stock.location').create(cr, uid, vals = {
                                                            'location_id': partner_id_obj.property_stock_customer.id,
                                                            'name':partner_id_obj.name,
                                                            'usage': 'customer',
                                                            'partner_id': partner_id,
                                                        }, context=context)
                #updates the property of stock for the partner
                self.write(cr, uid, partner_id, vals={
                                'property_stock_customer': partner_location_id,
                            }, context=context)
        return partner_id
res_partner()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
